package administrador.actions;


import java.util.Date;

import org.apache.log4j.Logger;

import model.HistoricCanvis;
import model.Persona;
import bo.PersonaBO;
import bo.HistoricCanvisBO;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

public class AltaAdministradorAction extends ActionSupport implements ModelDriven<Persona>{

	private static final long serialVersionUID = 1L;
	private static final Logger logger = Logger.getLogger(AltaAdministradorAction.class);
	private Persona persona;
	PersonaBO personaBO;
	HistoricCanvisBO historicCanvisBO;
	HistoricCanvis hc;
	private String nom;
	private String cognom1;
	private String cognom2;
	private String dni;
	private String email;
	private String usuari;
	private String contrassenya;
	private String confirmcontrassenya;
	private String sexe;
	
	
	
	
	@Override
	public String execute() throws Exception
	{
			int id;
			Date hoy = new Date();
			persona=new Persona();
			persona.setAdministrador(true);
			persona.setVoluntari(false);
			persona.setSolicitant(false);
			persona.setNom(nom);
			persona.setCognom1(cognom1);
			persona.setCognom2(cognom2);
			persona.setDni(dni);
			persona.setEmail(email);
			persona.setUsuari(usuari);
			persona.setContrassenya(contrassenya);
			if (sexe.equals("Home")==false)
			{
				persona.setEsHome(false);
			}
			else{ persona.setEsHome(true);}
			id=personaBO.altaAdministrador(persona);
			hc=new HistoricCanvis(persona,hoy, null,(byte)1);
			historicCanvisBO.guardarHistoric(hc);
			return SUCCESS;
	}
	
	
	@Override
	public void validate()
	{
		if (contrassenya.isEmpty())
    	{
    		   addFieldError( "contrassenya", "Tots els camps son obligatoris");
    	}
		if (nom.isEmpty())
    	{
    		   addFieldError( "nom", "Tots els camps son obligatoris");
    	}
		if (cognom1.isEmpty())
    	{
    		   addFieldError( "cognom2", "Tots els camps son obligatoris");
    	}
		if (cognom2.isEmpty())
    	{
    		   addFieldError( "cognom2", "Tots els camps son obligatoris");
    	}
		if (dni.isEmpty())
    	{
    		   addFieldError( "dni", "Tots els camps son obligatoris");
    	}
		if (email.isEmpty())
    	{
    		   addFieldError( "email", "Tots els camps son obligatoris");
    	}
		if (usuari.isEmpty())
    	{
    		   addFieldError( "usuari", "Tots els camps son obligatoris");
    	}
		if (confirmcontrassenya.isEmpty())
    	{
    		   addFieldError( "confirmcontrassenya", "Tots els camps son obligatoris");
    	}
		if(!contrassenya.equals(confirmcontrassenya))
		{
			addFieldError( "confirmcontrassenya", "La contrassenya no coincideix amb la introduda anteriorment");
		}
		
		boolean existeix=personaBO.buscarPersonaByField("usuari",usuari);
		if(existeix)
		{
			addFieldError( "usuari", "Aquest usuari ja existeix");
			
		}
		
		logger.debug("AltaServeiAction - validate()");
	}

	@Override
	public Persona getModel() {
		
		return persona;
	}
	public void setHistoricCanvisBO(HistoricCanvisBO historicCanvisBO) {
		this.historicCanvisBO = historicCanvisBO;
	}

	public Persona getPersona() {
		return persona;
	}

	public void setPersona(Persona persona) {
		this.persona = persona;
	}


	public PersonaBO getPersonaBO() {
		return personaBO;
	}


	public void setPersonaBO(PersonaBO personaBO) {
		this.personaBO = personaBO;
	}


	public String getNom() {
		return nom;
	}


	public void setNom(String nom) {
		this.nom = nom;
	}


	public String getCognom1() {
		return cognom1;
	}


	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}


	public String getCognom2() {
		return cognom2;
	}


	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}


	public String getDni() {
		return dni;
	}


	public void setDni(String dni) {
		this.dni = dni;
	}


	public String getEmail() {
		return email;
	}


	public void setEmail(String email) {
		this.email = email;
	}


	public String getUsuari() {
		return usuari;
	}


	public void setUsuari(String usuari) {
		this.usuari = usuari;
	}


	public String getContrassenya() {
		return contrassenya;
	}


	public void setContrassenya(String contrassenya) {
		this.contrassenya = contrassenya;
	}


	public String getConfirmcontrassenya() {
		return confirmcontrassenya;
	}


	public void setConfirmcontrassenya(String confirmcontrassenya) {
		this.confirmcontrassenya = confirmcontrassenya;
	}


	public String getSexe() {
		return sexe;
	}


	public void setSexe(String sexe) {
		this.sexe = sexe;
	}

}
