package dao;

import java.util.List;
import org.apache.log4j.Logger;
import org.hibernate.HibernateException;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Projections;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import util.HibernateUtil;
import model.Categoria;
import model.Servei;

public class CategoriaDAOImpl extends HibernateUtil implements CategoriaDAO {

			SessionFactory sessionFactory;
			@Autowired
			
			 private static final Logger logger = Logger.getLogger(CategoriaDAOImpl.class);
			 	@Transactional
			 	
			 	public void setSessionFactory(SessionFactory sf) {
					
					this.sessionFactory=sf;
				}			
			 	@SuppressWarnings("unchecked")
				@Transactional
				public List<Categoria> listCategories(){
				
					Session session = HibernateUtil.getSessionFactory().openSession();
				
					Transaction tx = session.beginTransaction();
					
					 String hql = "select distinct c from Categoria c left join c.serveis servei order by c.nomCategoria, servei.nomServei";
					 List<Categoria> results=(List<Categoria>) session.createQuery(hql).list();
						
				     tx.commit();
				     session.close();
					return results;
					    
					
				}
				@Override
				public Categoria getCategoriaById(int id) {
					Categoria cat=new Categoria();
			        Session session = HibernateUtil.getSessionFactory().openSession();
			        
			        try {
			        	session.beginTransaction();
			        	cat = (Categoria) session.get(Categoria.class,id);
			        	session.getTransaction().commit();
			        } catch (HibernateException e) {
			        	session.getTransaction().rollback();
			        } finally {
			        	session.close();
			        }
			        
					return cat;
				}
}
