package dao;


import java.util.List;
import org.apache.log4j.Logger;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import util.HibernateUtil;
import model.Persona;


public class PersonaDAOImpl extends HibernateUtil implements PersonaDAO  {

	SessionFactory sessionFactory;
	@Autowired
	
	 private static final Logger logger = Logger.getLogger(PersonaDAOImpl.class);
	 	@Transactional
	 	
	 	public void setSessionFactory(SessionFactory sf) {
			
			this.sessionFactory=sf;
		}
		public int altaVoluntari1(Persona persona){
			
			 Session session = HibernateUtil.getSessionFactory().openSession();
		     session.beginTransaction();
		     Integer id=(Integer) session.save(persona);
		     session.flush();
		     session.getTransaction().commit();
		     return id;
		}
	 
		public boolean validar(String usuari, String contrassenya)
		{
			Session session = HibernateUtil.getSessionFactory().openSession();
			
			Transaction tx = session.beginTransaction();
		
			String sql = "SELECT * FROM persona WHERE usuari = :u AND contrassenya = :c";
			Query query = session.createSQLQuery(sql);
			
			query.setParameter("u", usuari);
			query.setParameter("c", contrassenya);
			
			tx.commit();
		
			List results = query.list();
			session.close();
			if (results.isEmpty())
			{
				return false;
			}
			else
			{
				return true;
			}
					     
			
		}
		
		@SuppressWarnings("unchecked")
		public List<Persona> listPersona(){
			Session session = HibernateUtil.getSessionFactory().openSession();
	        session.beginTransaction();
	        List<Persona> personas = null;
	        try {	             
	            personas = (List<Persona>)session.createQuery("from persona").list();
	             
	        } catch (HibernateException e) {
	            e.printStackTrace();
	            session.getTransaction().rollback();
	        }
	        session.getTransaction().commit();
	        return personas;	
		}
		@SuppressWarnings("unchecked")
		@Override
		public boolean buscarPersonaByField(String camp, String valor) {
			logger.debug("cerquem la persona amb usuari=" + valor);
			List<Persona> results;
			Session session = HibernateUtil.getSessionFactory().openSession();
			Transaction tx = session.beginTransaction();
			String hql = "from Persona where usuari = :valor";
			Query query=session.createQuery(hql);
			
			//query.setString("camp",camp);
			query.setString("valor",valor);
			
			results=(List<Persona>) query.list();
			
		     tx.commit();
		     session.close();
		     if (results.isEmpty())
		     {
		    	 return false;
		     }
		     else
		     {
		    	 return true;
		
		     }
		}
		@Override
		public int altaAdministrador(Persona persona) {

			 Session session = HibernateUtil.getSessionFactory().openSession();
		     session.beginTransaction();
		     Integer   id=(Integer) session.save(persona);
		     session.flush();
		     session.getTransaction().commit();
		     return id;
			
		}
		@SuppressWarnings("unchecked")
		@Override
		public List<Persona> buscarPersona(String pnom, String pcognom1,
				String pcognom2, String pdni,
				String ppoblacio, String pcodiPostal, String pusuari, Integer tipus) {
			List<Persona> results;		
			Session session = HibernateUtil.getSessionFactory().openSession();
			Transaction tx = session.beginTransaction();
			String hqlA = "from Persona where nom like :n AND administrador LIKE :a  AND cognom1 like :c1  AND cognom2 like :c2 AND DNI like :d";// AND usuari like :u";
			
			String hqlV = "from Persona where nom like :n AND voluntari LIKE :v AND cognom1 like :c1  AND cognom2 like :c2 AND DNI like :d AND ciutat like :p AND codiPostal like :cp"; 
			
			Query query = null;
			
			if(tipus==1)
			{
				// Estamos buscando un Administrador
				
				query=session.createQuery(hqlA);	
				query.setBoolean("a", true);
				//query.setString("u", '%' + pusuari + '%');
			}
			if(tipus==2)
			{
				query=session.createQuery(hqlV);
				// Estamos buscando un Voluntario
				query.setString("p", '%' + ppoblacio + '%');
				query.setString("cp", '%'+ pcodiPostal +'%');
				query.setBoolean("v", true);
				
			}	
			query.setString("n", '%'+ pnom  +'%');
			query.setString("c1", '%' +pcognom1  + '%');
			query.setString("c2", '%'+ pcognom2  +'%');
			query.setString("d", '%' + pdni  + '%');	
			
			
			results=(List<Persona>) query.list();
			
		     tx.commit();
		     session.close();
			return results;
			
		}
		@SuppressWarnings("unchecked")
		@Override
		public List<Persona> aniversaris(String dia, String mes) {
			List<Persona> results;		
			Session session = HibernateUtil.getSessionFactory().openSession();
			Transaction tx = session.beginTransaction();
			Query query=null;
			
			if((dia.equals("-1")) && (mes.equals("-1")))
			{
				logger.debug("primero");
				//Todos los voluntarios
				String hql = "from Persona";
				query = session.createQuery(hql);
					
			}
			if ((dia.equals("-1")) && (!mes.equals("-1")))
			{
				logger.debug("segundo");
				//Todos los voluntarios de un mes concreto
				String hql = "from Persona where month(dataNaixament) like :mes";
				query = session.createQuery(hql);
				query.setString("mes", mes);
			}
			if((!dia.equals("-1")) && (mes.equals("-1")))
			{
				logger.debug("tercero");
				//Todos los voluntarios de un dia concreto de cualquier mes
				String hql = "from Persona where day(dataNaixament) like :dia";
				query = session.createQuery(hql);
				query.setString("dia",dia);
			}
			if((!dia.equals("-1")) && (!mes.equals("-1")))
			{
				logger.debug("cuarto dia="+dia+" y mes="+mes);
				//La ltima opcin es la de un da y un mes concreto
				String hql = "from Persona where day(dataNaixament) like :dia AND month(dataNaixament) like :mes";
				query = session.createQuery(hql);
				query.setString("dia",dia);
				query.setString("mes", mes);
			}
			
			results=(List<Persona>) query.list();
			
		     tx.commit();
		     session.close();
			return results;
				
		}
		@SuppressWarnings("unchecked")
		@Override
		public List<Persona> buscarExclosos() {
			List<Persona> results;		
			Session session = HibernateUtil.getSessionFactory().openSession();
			Transaction tx = session.beginTransaction();
	        String hql = "from Persona where solicitant=1 AND voluntari=0";
	        Query query =  session.createQuery(hql);	             
	        results=(List<Persona>) query.list();
			
		     tx.commit();
		     session.close();
			return results;	
		}
		
}
