package dao;

import informes.actions.VoluntarisServeisAction;

import java.util.List;

import model.Persona;
import model.Relaciopersonaservei;

import org.apache.log4j.Logger;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import util.HibernateUtil;

public class RelaciopersonaserveiDAOImpl implements RelaciopersonaserveiDAO {
	SessionFactory sessionFactory;
	@Autowired	
	 private static final Logger logger = Logger.getLogger(RelaciopersonaserveiDAOImpl.class);
	 @Transactional
	 public void setSessionFactory(SessionFactory sf) {
		
			this.sessionFactory=sf;
		}
	@Transactional
	public void guardarRelacio(Relaciopersonaservei rps) {
		Session session = HibernateUtil.getSessionFactory().openSession();
	     session.beginTransaction();
	     session.save(rps);
	     session.flush();
	     session.getTransaction().commit();	
		
	}
	@SuppressWarnings("unchecked")
	@Override
	public List<Relaciopersonaservei> voluntarisPerServei() {
		List<Relaciopersonaservei> results;		
		Session session = HibernateUtil.getSessionFactory().openSession();
		Transaction tx = session.beginTransaction();
        String sql = "Select s.nomServei as nomServei, CAST(count(r.Servei_idServei) AS CHAR)  AS nombre FROM relaciopersonaservei as r left join Servei as s on r.Servei_idServei=s.idServei group BY r.Servei_idServei";
        Query query =  session.createSQLQuery(sql);	
        query.setResultTransformer(Transformers.aliasToBean(Relaciopersonaservei.class)); 
        results=(List<Relaciopersonaservei>) query.list();
		
	     tx.commit();
	     session.close();
		return results;	
	}

}
