package dao;

import java.util.List;
import org.apache.log4j.Logger;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.Session;
import org.hibernate.Transaction;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import util.HibernateUtil;
import model.Servei;

public class ServeiDAOImpl extends HibernateUtil implements ServeiDAO  {

		SessionFactory sessionFactory;
		@Autowired
		
		 private static final Logger logger = Logger.getLogger(ServeiDAOImpl.class);
		 	@Transactional
		 	
		 	public void setSessionFactory(SessionFactory sf) {
				
				this.sessionFactory=sf;
			}
		 	@Transactional
			public int altaServei (Servei servei)
			{				
				 Session session = HibernateUtil.getSessionFactory().openSession();
			     session.beginTransaction();
			        
			     Integer id=(Integer) session.save(servei);
			     session.flush();
			     session.getTransaction().commit();
			     return id;
			}
		 		
		 	@SuppressWarnings("unchecked")
			
			public List<Servei> listServei(){
				Session session = HibernateUtil.getSessionFactory().openSession();
				Transaction tx = session.beginTransaction();
				Criteria crit=session.createCriteria(Servei.class);
				List<Servei> results = crit.list();
							
				tx.commit();			
				session.close();
				return results;
				
			}
			@Override
			public void baixaServeiById(int idServei) {
				Session session = HibernateUtil.getSessionFactory().openSession();
				Transaction tx = session.beginTransaction();
				String hql = "delete from Servei where idServei= :i";
				session.createQuery(hql).setLong("i", idServei).executeUpdate();				
			    tx.commit();
			    session.close();
				
			}
			@Override
			public Servei buscarServeiById(int idServei) {
				
				Servei result;
				Session session = HibernateUtil.getSessionFactory().openSession();
				Transaction tx = session.beginTransaction();
				String hql = "from Servei where idServei= :i";
				result=(Servei) session.createQuery(hql).setLong("i", idServei).uniqueResult();
				
			     tx.commit();
			     session.close();
			    return result;
			}
			@Override
			public void editarServei(Servei servei) {
				 Session session = HibernateUtil.getSessionFactory().openSession();
				 Transaction tx =  session.beginTransaction();			        
			     session.saveOrUpdate(servei);
			     session.flush();
			     tx.commit();
			     session.close();	   
				
			}
			
			@SuppressWarnings("unchecked")
			@Override
			public List<Servei> buscarServeis(String pnomServei, String pdescripcio, Integer idCategoria) {
				List<Servei> results;
				Session session = HibernateUtil.getSessionFactory().openSession();
				Transaction tx = session.beginTransaction();
				String hql = "from Servei where nomServei like :n AND descripcio like :d";
				Query query=session.createQuery(hql);
				// Si no s'ha seleccionat cap categoria no s'inclou el criteri
				if(idCategoria != -1)
				{
					hql=hql+ " AND categoria= :i";
					query=session.createQuery(hql);
					query.setLong("i", idCategoria);	
					
				}		
				
				query.setString("n", '%'+ pnomServei +'%');
				query.setString("d", '%' + pdescripcio + '%');
				
				results=(List<Servei>) query.list();
				
			     tx.commit();
			     session.close();
				return results;
			}
			@SuppressWarnings("unchecked")
			@Override
			public List<Servei> listServeiAgrupats() {
				List<Servei> results;
				Session session = HibernateUtil.getSessionFactory().openSession();
				Transaction tx = session.beginTransaction();
				String hql = "from Servei group by Categoria_idCategoria";
				Query query=session.createQuery(hql);
				results=(List<Servei>) query.list();
				tx.commit();
			    session.close();
				return results;
			}
}


