package model;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;


public class Solicitud implements java.io.Serializable {

	
	private static final long serialVersionUID = 1L;
	private int idSolicitud;
	private Persona personaBySolicitantIdPersona1;
	private Servei servei;
	private Persona personaByVoluntariIdPersona;
	private Date dataSolicitud;
	private Date dataTancament;
	private boolean estat;
	private String observacions;
	private Set<Valoracio> valoracios = new HashSet<Valoracio>(0);

	public Solicitud() {
	}

	public Solicitud(Persona personaBySolicitantIdPersona1, Servei servei,
			boolean estat) {
		this.personaBySolicitantIdPersona1 = personaBySolicitantIdPersona1;
		this.servei = servei;
		this.estat = estat;
	}

	public Solicitud(Persona personaBySolicitantIdPersona1, Servei servei,
			Persona personaByVoluntariIdPersona, Date dataSolicitud,
			Date dataTancament, boolean estat, String observacions,
			Set<Valoracio> valoracios) {
		this.personaBySolicitantIdPersona1 = personaBySolicitantIdPersona1;
		this.servei = servei;
		this.personaByVoluntariIdPersona = personaByVoluntariIdPersona;
		this.dataSolicitud = dataSolicitud;
		this.dataTancament = dataTancament;
		this.estat = estat;
		this.observacions = observacions;
		this.valoracios = valoracios;
	}

	public int getIdSolicitud() {
		return this.idSolicitud;
	}

	public void setIdSolicitud(int idSolicitud) {
		this.idSolicitud = idSolicitud;
	}

	public Persona getPersonaBySolicitantIdPersona1() {
		return this.personaBySolicitantIdPersona1;
	}

	public void setPersonaBySolicitantIdPersona1(
			Persona personaBySolicitantIdPersona1) {
		this.personaBySolicitantIdPersona1 = personaBySolicitantIdPersona1;
	}

	public Servei getServei() {
		return this.servei;
	}

	public void setServei(Servei servei) {
		this.servei = servei;
	}

	public Persona getPersonaByVoluntariIdPersona() {
		return this.personaByVoluntariIdPersona;
	}

	public void setPersonaByVoluntariIdPersona(
			Persona personaByVoluntariIdPersona) {
		this.personaByVoluntariIdPersona = personaByVoluntariIdPersona;
	}

	public Date getDataSolicitud() {
		return this.dataSolicitud;
	}

	public void setDataSolicitud(Date dataSolicitud) {
		this.dataSolicitud = dataSolicitud;
	}

	public Date getDataTancament() {
		return this.dataTancament;
	}

	public void setDataTancament(Date dataTancament) {
		this.dataTancament = dataTancament;
	}

	public boolean isEstat() {
		return this.estat;
	}

	public void setEstat(boolean estat) {
		this.estat = estat;
	}

	public String getObservacions() {
		return this.observacions;
	}

	public void setObservacions(String observacions) {
		this.observacions = observacions;
	}

	public Set<Valoracio> getValoracios() {
		return this.valoracios;
	}

	public void setValoracios(Set<Valoracio> valoracios) {
		this.valoracios = valoracios;
	}

}
